/*node {
  stage('SCM') {
    checkout scm
  }
  
  stage('SonarQube Analysis') {
    def mvn = tool 'MavenRT';
    withSonarQubeEnv() {
        echo "Analisis de código..."
  //    sh "${mvn}/bin/mvn clean verify sonar:sonar -Dsonar.qualitygate.wait=true -Dsonar.projectKey=rturcios77.demo_springdemo1_AX7RYgz7xrpOMyHQxGYZ"
    }
  }
  
  stage('Build') {
      steps {
          echo "Building .. ${BRANCH_NAME}"
      }
  }
}*/

node {
  stage('SCM') {
    checkout scm
  }
  stage('SonarQube Analysis') {
    def mvn = tool 'MavenRT';
    withSonarQubeEnv() {
      sh "${mvn}/bin/mvn sonar:sonar"
    }
  }
}

pipeline {
    environment {
        BRANCH_NAME =  "${GIT_BRANCH.split("/")[1]}"
    }
    agent any

    stages {
    /*
        stage('SonarQube Analysis') {
            steps {
                echo "Análisis de código con SonarQube..."
                //sh "mvn org.sonarsource.scanner.maven:sonar-maven-plugin:3.3.9:sonar -Dsonar.projectKey=rturcios77.demo_springdemo1_AX7RYgz7xrpOMyHQxGYZ -Dsonar.host.url=http://35.185.102.214 -Dsonar.login=1167e252e4f32ada2829f014dc17378fc3"
                //sh "mvn clean verify sonar:sonar -Dsonar.projectKey=rturcios77.demo_springdemo1_AX7RYgz7xrpOMyHQxGYZ -Dsonar.host.url=http://35.185.102.214 -Dsonar.login=1167e252e4f32ada2829f014dc17378fc3"
                // Comentario by RT
            }
        }
*/
        stage('build') {
            steps {
                echo "Building..${BRANCH_NAME}"  
                updateGitlabCommitStatus name: 'build', state: 'pending'
                script {
                    try { 
                        //sh "./mvnw clean install"
                        updateGitlabCommitStatus name: 'build', state: 'success'      
                    } catch (Exception e) {
                        echo 'Exception occurred: ' + e.toString()
                        updateGitlabCommitStatus name: 'build', state: 'failed'
                        sh 'exit 1'
                    }
                }
            }
        }
/*
        stage("Build image") {
            steps {
                script {
                    //myapp = docker.build("rutcios77.demo/hello:${env.BUILD_ID}")
                }
            }
        }
        
        stage("Push image") {
            steps {
                script {
                    docker.withRegistry('https://registry.hub.docker.com', 'dockerhub') {
                            myapp.push("latest")
                            myapp.push("${env.BUILD_ID}")
                    }
                }
            }
        }
*/
        stage('test') {
            steps {
                echo "Testing..${BRANCH_NAME}"
                updateGitlabCommitStatus name: 'test', state: 'pending'
                script {
                    try {
                        //sh ""
                        updateGitlabCommitStatus name: 'test', state: 'success'      
                    } catch (Exception e) {
                        echo 'Exception occurred: ' + e.toString()
                        updateGitlabCommitStatus name: 'test', state: 'failed'
                        sh 'exit 1'
                    }
                }
            }
        }

        stage('deploy') {
            steps {
                echo "Deploying..${BRANCH_NAME}"
                updateGitlabCommitStatus name: 'deploy', state: 'pending'
                script {
                    //sh "sed -i 's/hello:latest/hello:${env.BUILD_ID}/g' ./demo.yaml"
                    try {
                        updateGitlabCommitStatus name: 'deploy', state: 'success'      
                    } catch (Exception e) {
                        echo 'Exception occurred: ' + e.toString()
                        updateGitlabCommitStatus name: 'deploy', state: 'failed'
                        sh 'exit 1'
                    }
                }
            }
        }
    }
}
